#include "mns.h"

FILE *in_file;

void scan (struct in_addr, u_short);

void sighandler (int signo) { }

void vuln(char *scan_target, int children, u_short mns_opts) {
   static char host[60];
   static int i, status;

   SAin vuln;
   int ff;

   if(!(mns_opts & HOSTLIST)) {
      printf("Scanning single target '%s'\n", scan_target);
      if(ipv4_rslvhost(scan_target, &vuln)) scan(vuln.sin_addr, mns_opts);
      else printf("error: invalid target %s", scan_target);
      return;
   }
   /* open file */
   in_file = fopen (scan_target, "r");

   if (in_file == NULL) {
      printf("error: cannot open %s\n", scan_target);
      exit (EXIT_FAILURE);
   }

   printf("Reading hosts from file '%s'\n", scan_target);

   for (i = 0; i < children; i++) {
      fgets (host, 60, in_file);
      if (feof (in_file)) break;

      host[strlen (host) - 1] = '\0';	/* fgets keeps the linefeed */

      if (ipv4_rslvhost (host, &vuln)) {
         if (!(ff = fork ())) {
            scan (vuln.sin_addr, mns_opts);
	    exit (0);
         }
         else if (ff == -1)
            printf ("fork failed!\n");
      } else printf ("parse error: skipping '%s'\n", host);
   }

   if (!feof (in_file)) {
      for (;;) {
         wait (&status);
         fgets (host, 32, in_file);
         if (feof (in_file))
            break;

         host[strlen (host) - 1] = '\0'; /* fgets keeps the linefeed */

         if (ipv4_rslvhost (host, &vuln)) {
            if (!(ff = fork ())) {
               scan (vuln.sin_addr, mns_opts);
               exit (0);
            } else if (ff == -1) printf ("fork failed!\n");
         } else printf ("parse error: skipping '%s'\n", host);
      }
   }

   fclose (in_file);

   while (!((waitpid (-1, &status, WNOHANG) == -1) && (errno == ECHILD)));
}

void scan (struct in_addr target, u_short mns_opts) {
   struct in_addr localip;
   struct node *node1st, *walk, *ntemp;
   char *hostname;
   int *portlist = NULL;
   int i, pcount;

   if (mns_opts & RESOLVE) {
      hostname = malloc (60);
      ipv4_showname (AF_INET, &target, hostname, 60);
   } else {
      hostname = malloc (16);
      ipv4_ntop (AF_INET, &target, hostname, 16);
   }
   
   node1st = walk = calloc (sizeof (struct node), 1);

   walk = stealthscan(target, walk, &portlist, &localip);
   walk = checkos(target, walk, portlist, localip);

   if(portlist != NULL) {
      pcount = portlist[0] + 1;
      for (i = 1; i < portlist[0] + 1; i++) {
         switch (portlist[i]) {
            case 21:  if(mns_opts & VULNFTP ) walk = ftp (target, walk); break;
            case 80:  if(mns_opts & VULNCGI ) walk = cgi (target, walk); break;
            case 110: if(mns_opts & VULNQPOP) walk = qpop (target, walk); break;
            case 143: if(mns_opts & VULNIMAP) walk = imap (target, walk); break;
            case 111: if(mns_opts & VULNRPC ) walk = rpc (target, walk); break;
         }
      }
   }

   if (node1st->next != NULL) {
      printf ("\nHost: %s", hostname);
      for (walk = node1st; walk->next != NULL; walk = walk->next)
         printf (" %s", walk->string);
      putchar ('\n');
   }

   for (walk = node1st; walk != NULL;) {
      ntemp = walk->next;
      free (walk);
      walk = ntemp;
   }
}
